{************************************************}
{                                                }
{   BGI Demo Program                             }
{   Copyright (c) 1992 by Borland International  }
{                                                }
{************************************************}
{ ajout traduction en Franais 2008

program BgiLink;

{ This program demonstrates how to link graphics driver and font files
  into an EXE file. BGI graphic's drivers and fonts are kept in
  separate disk files so they may be dynamically loaded at runtime.
  However, sometimes it is preferable to place all auxiliary files
  directly into an .EXE. This program, along with its make file
  (BGILINK.MAK) and two units (BGIDRIV.PAS and BGIFONT.PAS) links all
  the drivers and fonts directly into BGILINK.EXE.

  Ce programme dmontre comment lier les drivers graphiques
  et les fichiers fonte dans un .EXE.Les drivers graphiques .BGI
  se trouve sur le disque dans des fichiers spars aussi ils
  sont chargs dynamiquement  l'excution.
  Quelques fois il est prfrable de placer tous les fichiers
  auxiliaires directement dans l'.EXE. Ce programme ainsi que son
  fichier make (BGILINK.MAK) et ses deux units
  (BGIDRIV.PAS and BGIFONT.PAS) lie tous les drivers et toutes
  les fontes directement dans  BGILINK.EXE.

  Have these 3 programs in the current drive or directory, or
  have them available via a path:

  Il faut avoir ces 3 programmes dans le disque ou le rpertoire
  courant, ou les avoir dans un chemin correct.
    MAKE.EXE     - Make utility that will build BGILINK.EXE
    MAKE.EXE     - utilitaire Make qui construira BGILINK.EXE

    BINOBJ.EXE   - utility program to convert any file into an .OBJ file
    BINOBJ.EXE   - utilitaire qui convertit un fichier en un fichier .OBJ

    Place in the current drive or directory the following files:
    Placer les fichiers suivants dans le disque ou le rpertoire
    courant:

    BGILINK.PAS  - Ce programme exemple

    BGIDRIV.PAS  - Pascal unit that will link the BGI drivers
                 - unit Pascal  ou serons lis les drivers BGI

    BGIFONT.PAS  - Pascal unit that will link in all BGI fonts
                 - unit Pascal  ou serons lies toutes les fontes BGI
    *.CHR        - BGI font files
                 - fichiers BGI fonte
    *.BGI        - BGI driver files
                 - fichiers BGI drivers
    BGILINK.MAK  - "make" file that builds BGIDRIV.TPU, BGIFONT.TPU, and
                   finally BGILINK.EXE
                 - "make" fichier qui construira BGIDRIV.TPU, BGIFONT.TPU,
                    et finallement BGILINK.EXE
  INSTRUCTIONS:
  1. Run MAKE on the BGILINK.MAK file by typing the following command
     at a DOS prompt:
      make -fBGIlink.mak

     Lancer MAKE avec le fichier BGILINK.MAK en tapant la commande
     suivante au prompt du DOS:
       make -fBGIlink.mak

     Using BINOBJ.EXE, this will first build .OBJ files out of the driver
     files (*.BGI) and then call Turbo Pascal to compile BGIDRIV.PAS.
     Next, the font files (*.CHR) will be converted to .OBJs and
     BGIFONT.PAS will be compiled. Finally, BGILINK.PAS will be compiled
     (it uses BGIDRIV.TPU and BGIFONT.TPU).

     Utilisera BINOBJ.EXE, cela construira des fichiers .OBJ spars
     des fichiers (*.BGI) et appelle Turbo Pascal pour compiler
     BGIDRIV.PAS.

  2. Run BGILINK.EXE. It contains all the drivers and all the fonts, so it
     will run on any system with a graphics card supported by the Graph
     unit (CGA, EGA, EGA 64 K, EGA monochrome, Hercules monochrome,
     VGA, MCGA, IBM 3270 PC and AT&T 6400).

     Lance BGILINK.EXE. Il contient tous les drivers et toutes
     les fontes, aussi il peut tourner sur nimporte quel systme
     dont la carte graphique supporte l'unit GRAPH  (CGA, EGA, EGA 64 K,
     EGA monochrome, Hercules monochrome,VGA, MCGA, IBM 3270 PC and AT&T 6400).

  EXPLANATION
  BGILINK.PAS uses BGIDRIV.TPU and BGIFONT.TPU in its uses statement:

      uses BGIDriv, BGIFont;
  EXPLICATION
    BGILINK.PAS utilise BGIDRIV.TPU and BGIFONT.TPU dans les
    dclarations uses :

      uses BGIDriv, BGIFont;

    Then, it "registers" the drivers it intends to use (in this case,
    all of them, so it will run on any graphics card). Then it registers
    all of the fonts it will use (again all of them, just for demonstration
    purposes) and finally it does some very modest graphics.

    Alors cela "enregistre" les drivers dans la clause uses ( dans cet
    example tous , aussi ils tournent sur nimporte quelle carte graphique)
    Puis cela "enregistre" toutes les fontes qui seront utilises( toutes
    pour cette dmonstration) et finalent fait quelque modestes
    graphiques.

    You can easily modify BGILINK.PAS for your own use by commenting out
    the calls to RegisterBGIdriver and RegisterBGIfont for drivers and
    fonts that your program doesn't use.
    Vous pouvez aisment modifier BGILINK.PAS pour votre utilisation
    en enlevant les commentaires qui appellent RegisterBGIdriver et
    RegisterBGIfont pour les drivers et les fontes que vous n'utilisez pas.

    For a detailed explanation of registering and linking drivers and fonts,
    refer to the RegisterBGIdriver and RegisterBGIfont descriptions in
    the printed documentation.
    Pour des explications plus dtailles sur l'enregistrement et le liage
    des drivers et des fontes se rfrer  la description imprime de
    RegisterBGIdriver et RegisterBGIfont
}

uses Graph,     { librarie de routines graphiques }
     BGIDriv,   { tous les drivers BGI }
     BGIFont;   { toutes les  fontes BGI  }
var
  GraphDriver, GraphMode, Error : integer;

procedure Abort(Msg : string);
begin
  Writeln(Msg, ': ', GraphErrorMsg(GraphResult));
  Halt(1);
end;

begin
  { enregistrement de tous les drivers }
  if RegisterBGIdriver(@CGADriverProc) < 0 then
    Abort('CGA');
  if RegisterBGIdriver(@EGAVGADriverProc) < 0 then
    Abort('EGA/VGA');
  if RegisterBGIdriver(@HercDriverProc) < 0 then
    Abort('Herc');
  if RegisterBGIdriver(@ATTDriverProc) < 0 then
    Abort('AT&T');
  if RegisterBGIdriver(@PC3270DriverProc) < 0 then
    Abort('PC 3270');


  { enregistrement de toutes les fontes }
  if RegisterBGIfont(@GothicFontProc) < 0 then
    Abort('Gothic');
  if RegisterBGIfont(@SansSerifFontProc) < 0 then
    Abort('SansSerif');
  if RegisterBGIfont(@SmallFontProc) < 0 then
    Abort('Small');
  if RegisterBGIfont(@TriplexFontProc) < 0 then
    Abort('Triplex');

  GraphDriver := Detect;                  { autodetect le hardware }
  InitGraph(GraphDriver, GraphMode, '');  { active les graphiques }
  if GraphResult <> grOk then             { y a il une erreur ? }
  begin
    Writeln('Graphics init error: ', GraphErrorMsg(GraphDriver));
    Halt(1);
  end;

  MoveTo(5, 5);
  OutText('Drivers and fonts were ');
  MoveTo(5, 20);
  SetTextStyle(GothicFont, HorizDir, 4);
  OutText('Built ');
  SetTextStyle(SmallFont, HorizDir, 4);
  OutText('into ');
  SetTextStyle(TriplexFont, HorizDir, 4);
  OutText('EXE ');
  SetTextStyle(SansSerifFont, HorizDir, 4);
  OutText('file!');
  Rectangle(0, 0, GetX, GetY + TextHeight('file!') + 1);
  Readln;
  CloseGraph;
end.
